<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>DeployToNodes xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/library/transformations/DeployToNodes.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.library.transformations;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.AllocUtils;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.ConfigUtils;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.DepCreation;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.DepUtils;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.ElementUtils;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.UIContext;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ModelManagement;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.m2minterfaces.IM2MTrafoModelSplit;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.templates.TemplateUtils;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.LazyCopier;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.LazyCopier.CopyExtResources;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.TransformationContext;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.filters.FilterKeepLanguage;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.filters.FilterKeepM2MTrafo;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.filters.FilterStateMachines;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.filters.FilterTemplateBinding;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.extensions.InstanceConfigurator;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.library.Messages;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.M2MTrafo;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Slot;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StructuralFeature;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment"> * This class executes all transformations during the instantiation of a</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment"> * deployment plan, i.e. 1. The reification of connectors (including template</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment"> * instantiation). This transformation targets a new model 2. Adding</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment"> * get_p/connect_q operations to a class (transformation within same model) 3.</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment"> * Remove all component types 4. distribute to nodes</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/transformations/DeployToNodes.html">DeployToNodes</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/m2minterfaces/IM2MTrafoModelSplit.html">IM2MTrafoModelSplit</a> {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String TRAFOS_DEFAULT_PLATFORM_DEFAULT_NODE = <span class="jxr_string">"trafos::defaultPlatform::defaultNode"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	@Override
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<strong class="jxr_keyword">public</strong> EList&lt;TransformationContext&gt; splitModel(<a href="../../../../../../../org/eclipse/papyrus/designer/transformation/profile/Transformation/M2MTrafo.html">M2MTrafo</a> trafo, Package deploymentPlan) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<em class="jxr_comment">// public void deployOnNodes(Map&lt;InstanceSpecification, InstanceSpecification&gt; instanceMap, Model existingModel, Model tmpModel) throws TransformationException, InterruptedException {</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		EList&lt;InstanceSpecification&gt; topLevelInstances = 
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  				DepUtils.getTopLevelInstances(TransformationContext.current.deploymentPlan);
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		<em class="jxr_comment">// now deploy on each node</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		DepCreation.initAutoValues(topLevelInstances);
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		EList&lt;InstanceSpecification&gt; nodes = AllocUtils.getAllNodes(topLevelInstances);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		EList&lt;TransformationContext&gt; splitModels = <strong class="jxr_keyword">new</strong> BasicEList&lt;TransformationContext&gt;();
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  		InstanceConfigurator.onNodeModel = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		<strong class="jxr_keyword">if</strong> (nodes.size() &gt; 0) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> nodeIndex = 0; nodeIndex &lt; nodes.size(); nodeIndex++) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				InstanceSpecification node = nodes.get(nodeIndex);
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  				<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  					splitModels.add(
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  							deployNode(topLevelInstances, TransformationContext.current.modelRoot, nodes, nodeIndex, node, false));
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  				}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  				<strong class="jxr_keyword">catch</strong> (InterruptedException e) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  					<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a>(e.getMessage());
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		}
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			InstanceSpecification defaultNode = (InstanceSpecification)
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  					ElementUtils.getQualifiedElementFromRS(TransformationContext.initialSourceRoot, TRAFOS_DEFAULT_PLATFORM_DEFAULT_NODE);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			<strong class="jxr_keyword">if</strong> (defaultNode == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a>(String.format(Messages.DeployToNodes_CantFindDefaultNode, TRAFOS_DEFAULT_PLATFORM_DEFAULT_NODE));
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  			}
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  				splitModels.add(
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  					deployNode(topLevelInstances, PackageUtil.getRootPackage(deploymentPlan), nodes, 0, defaultNode, <strong class="jxr_keyword">true</strong>));
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  			}
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			<strong class="jxr_keyword">catch</strong> (InterruptedException e) {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a>(e.getMessage());
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  			}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		}
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		<strong class="jxr_keyword">return</strong> splitModels;
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	<strong class="jxr_keyword">private</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/TransformationContext.html">TransformationContext</a> deployNode(EList&lt;InstanceSpecification&gt; topLevelInstances, Package existingModel, EList&lt;InstanceSpecification&gt; nodes, <strong class="jxr_keyword">int</strong> nodeIndex, InstanceSpecification node, <strong class="jxr_keyword">boolean</strong> allocAll)
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 			<strong class="jxr_keyword">throws</strong> TransformationException, InterruptedException {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		ModelManagement genModelManagement = ModelManagement.createNewModel(existingModel.getName());
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		Package generatedModel = genModelManagement.getModel();
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<em class="jxr_comment">// --------------------------------------------------------------------</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		checkProgressStatus();
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<em class="jxr_comment">// --------------------------------------------------------------------</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		LazyCopier targetCopier = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/LazyCopier.html">LazyCopier</a>(existingModel, generatedModel, CopyExtResources.ALL_EXCEPT, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		<em class="jxr_comment">// add pre-copy and post-copy listeners to the copier</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		targetCopier.preCopyListeners.add(FilterKeepM2MTrafo.getInstance());
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		targetCopier.preCopyListeners.add(FilterKeepLanguage.getInstance());
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		targetCopier.preCopyListeners.add(FilterStateMachines.getInstance());
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		targetCopier.preCopyListeners.add(FilterTemplateBinding.getInstance());
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		targetCopier.addResource(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		UIContext.monitor.setTaskName(String.format(Messages.InstantiateDepPlan_InfoDeployingForNode, node.getName()));
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		TransformationContext tc = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/TransformationContext.html">TransformationContext</a>();
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		tc.modelRoot = generatedModel;
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		tc.copier = targetCopier;
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		tc.mm = genModelManagement;
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<strong class="jxr_keyword">this</strong>.node = node;
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification is : topLevelInstances) {
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			<strong class="jxr_keyword">if</strong> (!TemplateUtils.withinPkgTemplate(is)) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				distributeToNode(targetCopier, allocAll, is);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		tc.deploymentPlan = (Package) targetCopier.get(TransformationContext.current.deploymentPlan);
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		tc.node = node;
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		<strong class="jxr_keyword">return</strong> tc;
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 	}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_javadoccomment">	 * Distribute an instance specification to the node by this</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 * @param allocAll</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 * @param slotPath</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 	<strong class="jxr_keyword">public</strong> InstanceSpecification distributeToNode(<a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/LazyCopier.html">LazyCopier</a> targetCopier, <strong class="jxr_keyword">boolean</strong> allocAll, InstanceSpecification instance)
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 			<strong class="jxr_keyword">throws</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a> {
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		<em class="jxr_comment">// once an instance is explicitly allocated on a partition (use of getNodes instead of getAllNodes)</em>
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		<em class="jxr_comment">// all of its sub-instances are allocated on the node as well</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<strong class="jxr_keyword">if</strong> (AllocUtils.getNodesOrThreads(instance).contains(node)) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 			allocAll = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		}
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		<em class="jxr_comment">// obtain implementation within source model</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		Classifier smImplementation = DepUtils.getClassifier(instance);
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		<strong class="jxr_keyword">if</strong> (smImplementation == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a>(String.format(
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 					Messages.DeployToNodes_CantFindImplementation, instance.getName()));
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		}
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 		<em class="jxr_comment">// copy instance to node specific model, no allocation-check is required, since it is done by recursive calls</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 		InstanceSpecification tmInstance = targetCopier.getCopy(instance);
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		<strong class="jxr_keyword">for</strong> (Slot slot : instance.getSlots()) {
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 			InstanceSpecification containedInstance = DepUtils.getInstance(slot);
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 			<strong class="jxr_keyword">if</strong> (containedInstance != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 				<strong class="jxr_keyword">if</strong> (!DepUtils.isShared(slot)) {
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 					StructuralFeature sf = slot.getDefiningFeature();
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 					<strong class="jxr_keyword">if</strong> (allocAll || AllocUtils.getAllNodes(containedInstance).contains(node)) {
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 						<em class="jxr_comment">// distribute subInstance</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 						InstanceSpecification tmContainedInstance = distributeToNode(targetCopier, allocAll, containedInstance);
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 						<strong class="jxr_keyword">if</strong> (sf instanceof Property) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 							<em class="jxr_comment">// execute configurator after recursive call on target model instance</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 							ConfigUtils.configureInstance(tmContainedInstance, (Property) sf, tmInstance);
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 						}
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 					
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 					}
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 				}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 			}
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		}
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		<strong class="jxr_keyword">return</strong> tmInstance;
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 	}
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> initiateProgressMonitor(<strong class="jxr_keyword">boolean</strong> generateCode, EList&lt;InstanceSpecification&gt; nodes) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 		<em class="jxr_comment">// -- calc # of steps for progress TransformationContext.monitor</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 		<em class="jxr_comment">// 1 (tmpModel creation) + 1 (reification) + 1 (tmpModel save)</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 		<em class="jxr_comment">// 5x on each deployed node (see below)</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		<em class="jxr_comment">// problem? Connector reification is a single, relatively long step</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		<strong class="jxr_keyword">int</strong> steps = 3;
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 		steps += 5 * nodes.size();
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		<strong class="jxr_keyword">if</strong> (generateCode) {
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 			steps += nodes.size();
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 		}
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		UIContext.monitor.beginTask(Messages.InstantiateDepPlan_InfoGeneratingModel, steps);
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 	}
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> checkProgressStatus() <strong class="jxr_keyword">throws</strong> InterruptedException {
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		<strong class="jxr_keyword">if</strong> (UIContext.monitor.isCanceled()) {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> InterruptedException();
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		}
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		UIContext.monitor.worked(1);
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 	}
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 	
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 	InstanceSpecification node;
<a class="jxr_linenumber" name="L210" href="#L210">210</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
